<template>
    <v-dialog v-model="dialog" persistent max-width="600px">
        <template v-slot:activator="{ on }">
            <v-btn v-if="user === null" color="primary" dark v-on="on" @click="openDialog">New</v-btn>
            <v-icon
                v-if="user !== null"
                small
                v-on="on"
                @click="openDialog"
            >
                edit
            </v-icon>
        </template>
        <v-card>
            <v-card-title>
                <span class="headline">User Profile</span>
            </v-card-title>
            <v-card-text>
                <v-container grid-list-md>
                    <v-layout wrap>
                        <v-flex xs12>
                            <v-text-field label="Name*" required v-model="item.name"></v-text-field>
                        </v-flex>
                        <v-flex xs12>
                            <v-text-field label="Email*" required v-model="item.email"></v-text-field>
                        </v-flex>
                        <v-flex xs12>
                            <v-text-field label="Password*" type="password" required
                                          v-model="item.password"></v-text-field>
                        </v-flex>
                    </v-layout>
                </v-container>
                <small>*email required field</small>
            </v-card-text>
            <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn color="blue darken-1" flat @click="close">Close</v-btn>
                <v-btn color="blue darken-1" flat @click="save">Save</v-btn>
            </v-card-actions>
        </v-card>
    </v-dialog>
</template>

<script>
    import helpers from './../../helpers';
    export default {
        name: "NewUser",
        props: {
            user: {
                default: null
            }
        },
        data() {
            return {
                dialog: false,
                item: {
                    name: '',
                    email: '',
                    password: '',
                },
                defaultItem: {
                    name: '',
                    email: '',
                    password: '',
                }
            }
        },
        methods: {
            openDialog() {
                if (this.user !== null) {
                    this.item = this.user;
                }else {
                    this.item = this.defaultItem;
                }
            },
            close() {
                this.dialog = false;
            },
            save() {
                if (this.user !== null) {
                    this.update();
                } else {
                    this.store();
                }
            },
            store() {
                axios.post('panel/user', this.item).then(response => {
                    console.log(response);
                    this.dialog = false;
                }).catch(error => helpers.errorHandler(error));
            },
            update() {
                axios.put('panel/user/' + this.user.id, this.item).then(response => {
                    this.dialog = false;
                }).catch(error => helpers.errorHandler(error));
            }
        }
    }
</script>

<style scoped>

</style>
